#import <AppKit/NSWorkspace.h>

/*NSWorkspaceWillSleepNotification

Posted before the machine goes to sleep. An observer of this message can delay sleep for up to 30 seconds while handling this notification. 

The notification object is the shared NSWorkspace instance. The notification does not contain a userInfo dictionary.
Availability
Available in Mac OS X v10.3 and later.*/
extern NSString *NSWorkspaceWillSleepNotification;

/*NSWorkspaceDidWakeNotification

Posted when the machine wakes from sleep.

The notification object is the shared NSWorkspace instance. The notification does not contain a userInfo dictionary.
Availability
Available in Mac OS X v10.3 and later.*/
extern NSString *NSWorkspaceDidWakeNotification;

@interface NSWorkspace (hys)

/*absolutePathForAppBundleWithIdentifier:

Returns the absolute file-system path of an application bundle.

- (NSString *)absolutePathForAppBundleWithIdentifier:(NSString *)bundleIdentifier
Parameters
bundleIdentifier

The bundle identifier string. This value corresponds to the value in the CFBundleIdentifier key of the application’s Info.plist file. For example, the bundle identifier of the TextEdit application is com.apple.TextEdit.
Return Value

The file system path to the application bundle identified by bundleIdentifier, or nil if the bundle cannot be found.
Availability
Available in Mac OS X v10.3 and later.*/
- (NSString *)absolutePathForAppBundleWithIdentifier:(NSString *)bundleIdentifier;


@end
